# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>   # noqa: E501

    The version of the OpenAPI document: 0.36.0.dev6
    Generated by: https://openapi-generator.tech
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr

class BalanceFloor(BaseModel):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """
    balance: StrictInt = Field(..., description="Minimum balance in the account's currency. Unit in cents.")
    linked_account_id: Optional[StrictStr] = Field(None, description="ID of linked backing account for just-in-time (JIT) funding of transactions to maintain the balance floor ")
    overdraft_account_id: Optional[StrictStr] = Field(None, description="ID of linked backing account for just-in-time (JIT) funding of transactions to maintain the balance floor This attribute is a deprecated alias for linked_account_id. ")
    __properties = ["balance", "linked_account_id", "overdraft_account_id"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> BalanceFloor:
        """Create an instance of BalanceFloor from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> BalanceFloor:
        """Create an instance of BalanceFloor from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return BalanceFloor.parse_obj(obj)

        _obj = BalanceFloor.parse_obj({
            "balance": obj.get("balance"),
            "linked_account_id": obj.get("linked_account_id"),
            "overdraft_account_id": obj.get("overdraft_account_id")
        })
        return _obj

