# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>   # noqa: E501

    The version of the OpenAPI document: 0.36.0.dev6
    Generated by: https://openapi-generator.tech
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional
from pydantic import BaseModel, Field, StrictStr, validator

class BaseAccountVerification(BaseModel):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """
    creation_time: Optional[datetime] = Field(None, description="The time at which verification was first completed.")
    last_updated_time: Optional[datetime] = Field(None, description="The time at which verification was last updated.")
    status: StrictStr = Field(..., description="The status of verification")
    vendor: StrictStr = Field(..., description="The vendor used for verifying the account")
    __properties = ["creation_time", "last_updated_time", "status", "vendor"]

    @validator('status')
    def status_validate_enum(cls, v):
        if v not in ('VERIFIED', 'UNVERIFIED'):
            raise ValueError("must validate the enum values ('VERIFIED', 'UNVERIFIED')")
        return v

    @validator('vendor')
    def vendor_validate_enum(cls, v):
        if v not in ('PLAID', 'MANUAL', 'FINICITY'):
            raise ValueError("must validate the enum values ('PLAID', 'MANUAL', 'FINICITY')")
        return v

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> BaseAccountVerification:
        """Create an instance of BaseAccountVerification from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> BaseAccountVerification:
        """Create an instance of BaseAccountVerification from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return BaseAccountVerification.parse_obj(obj)

        _obj = BaseAccountVerification.parse_obj({
            "creation_time": obj.get("creation_time"),
            "last_updated_time": obj.get("last_updated_time"),
            "status": obj.get("status"),
            "vendor": obj.get("vendor")
        })
        return _obj

