# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>   # noqa: E501

    The version of the OpenAPI document: 0.36.0.dev6
    Generated by: https://openapi-generator.tech
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr, validator

class Detail(BaseModel):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """
    description: Optional[StrictStr] = Field(None, description="Human-readable description explaining the individual check.")
    label: Optional[StrictStr] = Field(None, description="Human-readable grouping describing the aspect of the customer's identity examined by this check.")
    result: Optional[StrictStr] = Field(None, description="The result of the individual check. One of the following: * `PASS` – the check passed contributing to a positive outcome (or accepted verification result). * `WARN` – the results of the check were inconclusive and might require review. * `FAIL` – the check failed and might result in a failing outcome (or rejected verification_result). ")
    vendor_code: Optional[StrictStr] = Field(None, description="Machine-readable description of the individual check. This field contains vendor-specific terms and may not be populated in all cases.")
    __properties = ["description", "label", "result", "vendor_code"]

    @validator('result')
    def result_validate_enum(cls, v):
        if v is None:
            return v

        if v not in ('PASS', 'WARN', 'FAIL'):
            raise ValueError("must validate the enum values ('PASS', 'WARN', 'FAIL')")
        return v

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Detail:
        """Create an instance of Detail from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Detail:
        """Create an instance of Detail from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return Detail.parse_obj(obj)

        _obj = Detail.parse_obj({
            "description": obj.get("description"),
            "label": obj.get("label"),
            "result": obj.get("result"),
            "vendor_code": obj.get("vendor_code")
        })
        return _obj

