# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>   # noqa: E501

    The version of the OpenAPI document: 0.36.0.dev6
    Generated by: https://openapi-generator.tech
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import Optional
from pydantic import BaseModel, Field, StrictStr

class FulfillmentDetails(BaseModel):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """
    ship_date: Optional[date] = Field(None, description="The date that the card was shipped as reported by the card fulfillment provider")
    shipping_method: Optional[StrictStr] = Field(None, description="The specific shipping method as reported by the card fulfillment provider")
    tracking_number: Optional[StrictStr] = Field(None, description="The shipment tracking number")
    __properties = ["ship_date", "shipping_method", "tracking_number"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> FulfillmentDetails:
        """Create an instance of FulfillmentDetails from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "ship_date",
                            "shipping_method",
                            "tracking_number",
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> FulfillmentDetails:
        """Create an instance of FulfillmentDetails from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return FulfillmentDetails.parse_obj(obj)

        _obj = FulfillmentDetails.parse_obj({
            "ship_date": obj.get("ship_date"),
            "shipping_method": obj.get("shipping_method"),
            "tracking_number": obj.get("tracking_number")
        })
        return _obj

